#include "../../include/ctx.h"
#include "../../include/pool.h"
#include "../../include/util.h"
#include "../../include/error.h"

lm_pkg_t *lm_ctx_package_get(lm_ctx_t *ctx, char *name, char *version) {
  lm_pool_t *pool = ctx->pools;
  lm_pkg_t *pkg = NULL;

  while (NULL != pool) {
    if((pkg = lm_pool_package_find(pool, name, version)) != NULL)
      break;
    pool = pool->next;
  }

  if(NULL == pool && NULL == pkg){
    lm_error_set(LM_ERR_PkgNotFound);
    return NULL;
  }

  if(!lm_pool_package_get(pool, pkg))
    return NULL;

  return pkg;
}

lm_pkg_t *lm_ctx_package_install(lm_ctx_t *ctx, char *name, char *version){
  return NULL;
}
